// -*- c++ -*-
// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!
#ifndef _GOOCANVASMM_PATH_H
#define _GOOCANVASMM_PATH_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 1998-2006 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <goocanvasmm/itemsimple.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GooCanvasPath GooCanvasPath;
typedef struct _GooCanvasPathClass GooCanvasPathClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Goocanvas
{ class Path_Class; } // namespace Goocanvas
#endif //DOXYGEN_SHOULD_SKIP_THIS

namespace Goocanvas
{

/*
_WRAP_ENUM(PathCommandType,GooCanvasPathCommandType, s#^CANVAS_##)
*/


class Path : public Goocanvas::ItemSimple
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Path CppObjectType;
  typedef Path_Class CppClassType;
  typedef GooCanvasPath BaseObjectType;
  typedef GooCanvasPathClass BaseClassType;

  // noncopyable
  Path(const Path&) = delete;
  Path& operator=(const Path&) = delete;

private:  friend class Path_Class;
  static CppClassType path_class_;

protected:
  explicit Path(const Glib::ConstructParams& construct_params);
  explicit Path(GooCanvasPath* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:

  Path(Path&& src) noexcept;
  Path& operator=(Path&& src) noexcept;

  virtual ~Path() noexcept;

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GooCanvasPath*       gobj()       { return reinterpret_cast<GooCanvasPath*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GooCanvasPath* gobj() const { return reinterpret_cast<GooCanvasPath*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GooCanvasPath* gobj_copy();

private:

protected:

  //TODO: I doubt that ustring is a sensible type for the data. murrayc.
  explicit Path(const Glib::ustring& data );
  

public:

  
  static Glib::RefPtr<Path> create(const Glib::ustring& data);


  //We put these in item.hg instead.
  //See the comment there.
  //_WRAP_PROPERTY("x", double)
  //_WRAP_PROPERTY("y", double)
  //_WRAP_PROPERTY("width", double)
  //_WRAP_PROPERTY("height", double)
  /** The sequence of path commands.
   *
   * @return A PropertyProxy_WriteOnly that allows you to set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_WriteOnly< Glib::ustring > property_data() ;


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};


}


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Goocanvas::Path
   */
  Glib::RefPtr<Goocanvas::Path> wrap(GooCanvasPath* object, bool take_copy = false);
}


#endif /* _GOOCANVASMM_PATH_H */

